<template>
  <div class="container service_offering">
    <div class="structure" v-if="service_overview">
      <div id="service_overview">
        <ServiceOfferingOverview v-bind:service="service_overview" />
      </div>
      <div id="service_plans">
        <ServiceOfferingPlan v-bind:plans="service_plans" v-bind:service-id="service_overview.id" />
      </div>
      <div id="service_menu">
        <ServiceOfferingMenu />
      </div>
      <router-view></router-view>
    </div>
    <div v-else-if="error" class="error">No Service Found</div>
    <div v-else class="loading">Service Loading</div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import ServiceOfferingOverview from "@/components/ServiceOfferingOverview.vue";
import ServiceOfferingPlan from "@/components/ServiceOfferingPlan.vue";
import ServiceOfferingReleaseNotes from "@/components/ServiceOfferingReleaseNotes.vue";
import ServiceOfferingReview from "@/components/ServiceOfferingReview.vue";
import ServiceOfferingMenu from "@/components/ServiceOfferingMenu.vue";
import { CatalogItem } from "@/services/osb/catalog";
import _ from "lodash";

@Component({
  components: {
    ServiceOfferingOverview,
    ServiceOfferingMenu,
    ServiceOfferingPlan,
    ServiceOfferingReleaseNotes,
    ServiceOfferingReview
  }
})
export default class ServiceOffering extends Vue {
  get error() {
    return null;
  }

  get service_overview(): CatalogItem {
    return this.$store.getters["catalog/getOfferingByID"](
      this.$route.params.id
    );
  }

  get service_plans() {
    return this.$store.getters["catalog/getOfferingByID"](this.$route.params.id)
      .plans;
  }

  get service_release_notes() {
    return this.$store.getters["catalog/getOfferingByID"](this.$route.params.id)
      .metadata.release_notes;
  }

  get service_reviews() {
    return this.$store.getters["catalog/getOfferingByID"](this.$route.params.id)
      .metadata.reviews;
  }

  private created() {
    try {
      this.$store.dispatch("catalog/fetchCatalog");
    } catch (e) {
      console.log("Unable to load catalog");
    }
  }
}
</script>

<style lang="scss" scoped>
.service_offering {
  display: flex;
}

.structure {
  display: grid;
  justify-content: space-between;
  width: 100%;
  grid-template-columns: 1fr 400px;
  grid-template-rows: auto;
  grid-template-areas:
    "overview     plans"
    "menu         plans"
    "release_notes    release_notes"
    "reviews      reviews";

  @include media(">desktop") {
    grid-template-areas:
      "overview     plans"
      "menu         plans"
      "release_notes    release_notes"
      "reviews      reviews";
  }
}

#service {
  &_overview {
    grid-area: overview;
    padding-top: 50px;
  }

  &_menu {
    grid-area: menu;
  }

  &_plans {
    grid-area: plans;
  }

  &_release_notes {
    grid-area: release_notes;
  }

  &_reviews {
    grid-area: reviews;
  }
}

.error {
  display: flex;
  align-content: center;
  justify-content: center;
}
</style>
